﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Text;
using AdiIRCAPI; // Include the API

namespace MyPlugin
{
    public class MyPlugin : IPlugin // Reference this is a plugin
    {
        private string myName = "MyPlugin";
        private string myDescription = "Sample plugin";
        private string myAuthor = "Per Amundsen";
        private string myVersion = "1.0.0";
        private string myEmail = "amundsen@gmail.com"; // optional

        IPluginHost myHost = null;
        ITools myTools = null;

        public string Description
        {
            get { return myDescription; }
        }

        public string Author
        {
            get { return myAuthor; }
        }

        public string Name
        {
            get { return myName; }
        }

        public string Version
        {
            get { return myVersion; }
        }

        public string Email
        {
            get { return myEmail; }
        }

        public IPluginHost Host
        {
            get { return myHost; }
            set { myHost = value; }
        }

        public ITools Tools
        {
            get { return myTools; }
            set { myTools = value; }
        }

        public MyPlugin()
        {

        }

        public void Initialize()
        {
            // This is called when the plugin is loaded
            // Suscribe to delegates here
            myHost.OnUserJoin += new UserJoin(myHost_OnUserJoin);
            MessageBox.Show("Hello world");
        }

        void myHost_OnUserJoin(IServer Server, IChannel Channel, out EatData Return)
        {
            MessageBox.Show("I just joined " + Channel.Name);

            Return = EatData.EatNone; // Dont eat this
        }

        public void Dispose()
        {
            // This is called when the plugin is unloaded
            MessageBox.Show("Bye world");
        }
    }
}
